Тёмный

Buy/Sell Stock With K transactions To Maximize Profit Dynamic Programming 

Tushar Roy - Coding Made Simple
Подписаться 245 тыс.
Просмотров 177 тыс.
50% 1

Опубликовано:

 

20 окт 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 224   
@ShikharPrasoon
@ShikharPrasoon 5 лет назад
Don't miss the optimization at 13:23. It reduces the time complexity from O(k*d*d) to O(k*d) k = max transactions, d = total days
@speedmishra13
@speedmishra13 5 лет назад
Thanks. I would still start with the first solution in an interview and then optimize
@ShivamKumar-qv6em
@ShivamKumar-qv6em 3 года назад
@@abhishekkumar-ui7xm yupp
@sahilanower9189
@sahilanower9189 2 года назад
Thanks this saved me some time! 😅
@brucezu574
@brucezu574 8 лет назад
Can not be btter! Thank you so much! Tushar Roy. The formula is right. Just make it clear: Formula is maxDiff = max(maxDiff, T[i-1][j-1] - prices[j-1]) T[i][j] = max(T[i][j-1], prices[j] + maxDiff) or T[i][j] = max(T[i][j-1], prices[j] + maxDiff) maxDiff = max(maxDiff, T[i-1][j] - prices[j]) // used for next turn
@lakshaygarg101
@lakshaygarg101 4 года назад
1
@NizGravit
@NizGravit 4 года назад
First attempt: Me: "What!?" Second attempt: Me: "Aha, that how we calculating T[ i ] [ j ] " Third attempt: Me: "What!? No, I should take a walk" Fourth attempt (after the walk): Me: "Mother of fucking god. So we just looking for the difference between previous day profit and previous day price to find if it's the max, and if it is we are adding it to the price on an actual day! And if it's larger than previous day than it's a max profit!" 3 hr 20 min. I'm fucking happy...
@astroash
@astroash 4 года назад
Damn Vitalii
@sulaimant5690
@sulaimant5690 3 года назад
Just reached the point where your final Conclusion made sense. Thanks, BTW, for the Motivation :P
@salilkansal4988
@salilkansal4988 3 года назад
Your Fourth attempt makes most sense. So basically if I need to find an M from 0..j-1 and I already know the best M from 0..j-2 then just compare previous M with the new j-1 index. This is similar to what you would do if you need to store some prefix max for an array.
@biboswanroy6699
@biboswanroy6699 4 года назад
You have the biggest playlist on hard DPs, worked damn hard man
@azn0180
@azn0180 4 года назад
Such a genius explanation. I looked many other videos and people skipped the most important thing which is the thought process. Thanks! I am a fan now.
@effy1219
@effy1219 7 лет назад
this is the clearest explanation I've seen on the internet thanks
@venkatakrishnansowrirajan573
@venkatakrishnansowrirajan573 5 лет назад
Tushar, you're explanation is pretty neat and simple to understand. Thanks for explaining these problems simpler and easy to understand.
@subashthapa5475
@subashthapa5475 3 года назад
I finally understood all the leetcode solution by watching your video. Concept is clear now. Thanks.
@jiayincao254
@jiayincao254 7 лет назад
I believe a better formula is the following: T[i][j] = max{ T[i][j-1] , prices[j]-prices[m]+T[i][m-1] } m goes from 0 to j-1. Please notice that I use m-1 instead of m in the video. Because T[i][j] represents the maximal profit that one can get at the end of the day j, inclusive. That said in the formula of the video, where the last term is T[i][m], it could be count twice. However, T[i][j] may have hidden the issue in the algorithm so that it won't show up. My two cents, the above formula makes it clearer. Anyway, great tutorial. Always love watching this guy's video, :)
@taowang9735
@taowang9735 7 лет назад
i think either m or m - 1 is ok, whether we allow sell and buy at the same day has no effect on max profit. 1) if we have up-rising price array, we will always return max profit by buying at 1st day and sell at last day 2) if we have down-falling price array, we will have a natural gap that makes the condition become "we won't sell and buy at the same day", which is that we maintain the old max profit and wait for the next up-rising period to buy. two things combined, using m can represent m - 1 so we don't have to worry about "counting twice". (and also m is easier to write since u don't need to deal with boundary case where m - 1 could be -1)
@shuaishao621
@shuaishao621 6 лет назад
Cannot thank you enough for the tutorial! I've seen the formula in other blogs but got quite confused by the idea behind it, you just saved me tons of time!
@varshath2
@varshath2 8 лет назад
I've been trying to solve this problem for a long time! Almost everything on the internet was complex and confusing. Your approach is best solution available on the internet!
@huali327
@huali327 8 лет назад
Frankly, I was working on this problem on leetcode and was not able to understand the solutions can be found online. But your explanation is so clear and well organized. I dunno remember how many your videos I've watched and they always help. I feel I must say thank you to you!
@ThePaullam328
@ThePaullam328 Год назад
You actually explain how to derive maxDiff from the recurrence relation formula, you're such a champ Tushar!
@cristianouzumaki2455
@cristianouzumaki2455 4 года назад
Sir, your videos are a gem. I am pretty sure I will come back in 2026 to watch this again.
@StarPlatinum3000
@StarPlatinum3000 5 лет назад
Thanks a lot for this! I just could not understand the final optimization step before watching this video, which reduces the time complexity from O(k*n^2) to O(k*n), probably because I kept trying to understand the "best" solution without trying to understand the slightly worse solutions. I believe there is a way to reduce the space complexity to O(n) as well, by making two arrays called prev and next, each of size n=prices.size(), and calculating the maxDiff from prev while filling the solution to the DP in next. We can further reduce the space to just one n-sized array, named T, by keeping two variables named maxDiff and newMaxDiff, and calculating newMaxDiff=max(maxDiff, T[j] - prices[j]), then using maxDiff to calculate T[j], and then setting maxDiff = newMaxDiff for the next iteration to use. Another thing I realized is that if K is greater than or equal to N/2, then the array stops changing between iterations. So we can completely skip this algorithm and use the standard *maximize profit with any number of transactions* solution.
@swethamuthuvel6526
@swethamuthuvel6526 3 года назад
In 25:05 it must have been like maxdiff = max(maxdiff, T[i-1][j-1]-price[j-1]) , explanation is awesome👏👍
@freezefrancis
@freezefrancis 8 лет назад
Well done Tushar .. :) Hats Off for your clarity in the explainations (y)
@sherryfan161
@sherryfan161 4 года назад
Amazing explanation! Finally understood why this works :)
@xgreenbeansoupx
@xgreenbeansoupx 7 лет назад
Thank you for the great explanation and especially the step by step process of moving from a logical initial algorithm to an even faster one. One thing I wanted to mention is specifically about the implementation of the code. Maxdiff should be updated prior to determining the max value of T[i][j] because we need to know if the previous maxDiff is larger or the new difference that was introduced.
@sohamchakravarty472
@sohamchakravarty472 8 лет назад
Great video Tushar. You solved an all time mystery so simply. Brilliant!!! Thanks
@chetanshrivastava3762
@chetanshrivastava3762 4 года назад
Thanks dear .Now I am able to understand the logic behind the problem.Brilliant,Awesome work...
@kevinshindler7014
@kevinshindler7014 8 лет назад
The video is nice. I think it would be great if you can also discuss about the Best Time to Buy and Sell Stock with Cooldown. Thanks a lot!
@kaichenghu3826
@kaichenghu3826 6 лет назад
Nice work, Tushar! Thank you for explaining in such a clear way
@shoryagoswami3463
@shoryagoswami3463 3 года назад
Hi.. great job man..!! Your videos are always a treat to watch. Just one query though - we should only be allowed to either buy or sell on a day right but your explanation seems to be considering that one could sell and then buy on the same day (Mth day) marking the beginning of another txn. I don't think that's possible or is it? Kindly correct me if wrong
@bird6472
@bird6472 2 года назад
Yes I've seen this problem presented as being unable to buy and sell on the same day.
@KemoLeno
@KemoLeno 7 лет назад
Hi. Thanks for your great video. In your 2nd part of the equation, when you are looking for the best transaction {m-->i}, why do you use T[i-1][m] instead of T[i-1][m-1]. The thing is If you found that m is the best day on which to buy stock for transaction (i), then you can't include that day in T[i-1][m] since you are not allowed to use the same day to both sell stock for the (i-1)th transaction and buy stock for the (i)th transaction. I would appreciate if you correct my understanding if needed :-)
@prakhargandhi8919
@prakhargandhi8919 6 лет назад
He used it after the computing the transaction so this step is used in next transaction computation actually.
@shuaizhao5622
@shuaizhao5622 5 лет назад
Bro. I had the same confusion but later on I realize that we were wrong. price[j] - price[m] is the earning of buy at m and sell at j. T[i-1][m] is to sell at m. If we add T[i-1][m] + price[j] - price[m], it means we do nothing at m! It cancels out to buy and sell together.
@varungoyal2975
@varungoyal2975 5 лет назад
@@shuaizhao5622 Yes that is tricky part. Prior to watch that video i was stuck throughout a day after assuming T[i-1][m-1] + price[j] - price[m] :(
@saurabhakumarnayak5879
@saurabhakumarnayak5879 5 лет назад
@@shuaizhao5622 T[i-1][m] may or may not include selling at mth day. However if it does include selling at mth day then the question arises are we allowed to first sell and then buy at the same day?
@electric336
@electric336 2 года назад
I had the same question. It seems his solution is allowing for buying and selling on the same day, which I don't believe the leetcode question allows.
@jdragon8184
@jdragon8184 4 года назад
i came up with the code for infinte transaction ,thnx to ur video sir i came to know what the problem really was and ur solution saved my lazy ass
@raihanulalamhridoy4714
@raihanulalamhridoy4714 2 года назад
Thank you very much. Your explanation was better than other videos.
@charvakpatel962
@charvakpatel962 8 лет назад
I just never got this question but now i have just because of you
@Vendettaaaa666
@Vendettaaaa666 4 года назад
lol
@yanivgardi9028
@yanivgardi9028 8 лет назад
thanks a lot Tushar you made a complicated problem, easy and simple to grab
@rakesh0054
@rakesh0054 7 лет назад
Thanks for the effort in preparing this video. It was an almost perfect explanation.
@sanchayshrivas7749
@sanchayshrivas7749 3 года назад
Hats Off, the amount of effort you've put into really deserves an applaud, the clearest explanation I've seen, you make it understandable, sublime!
@益达-k6q
@益达-k6q 6 лет назад
Brilliant! Thank you ! Not until I watched this video did I realize the solution!
@momkid90
@momkid90 Год назад
Best explanation of this algorithm. Thank you.
@kobebyrant9483
@kobebyrant9483 3 года назад
best dynamic programming tutorial ever!
@rashmikiranpandit8962
@rashmikiranpandit8962 4 года назад
Why is it not this: T[i][j] = price[j]-price[m] + T[i-1][m-1] instead of this: T[i][j] = price[j]-price[m] + T[i-1][m] As if T[i-1][m] contains the case that we are selling the stock on mth day, then we cannot buy the stock on mth day. Pls explain
@vrukshanikam6743
@vrukshanikam6743 4 года назад
It actually doesn't matter. If you sell a stock on some day and buy the stock on that same it's as if you didn't do any transaction. So for example at 8:36 , he assumes that we bought 2 on day 0, sold it on day 1 at 5, then bought 5 again at day 1 and sold it at 7 on day 2. It's as good as we never did anything on day 2 and directly sold the stock priced 2 at a price 7.
@patelmiki
@patelmiki 4 года назад
That true and its correct explanation as we can not buy and sell on same day. Above solution works and makes code concise but during interview any followup question would be hard to explain and prove, if we use T[i][j] = price[j]-price[m] + T[i-1][m]. so we can use if (m==0) then T[i][j] = price[j]-price[m] else T[i][j] = price[j]-price[m] + T[i-1][m-1]. Then move to optimized solution.
@lakshyaagarwal2005
@lakshyaagarwal2005 4 года назад
@@patelmiki Willl this really work bro? check at 9:50
@tapeshmittal3287
@tapeshmittal3287 8 лет назад
Thanks for the great video. Just one question. Is this solution is based on the assumption that we might sell and buy on the same day? I'm asking this because we are adding [k-1][m] and not [k-1][m-1].
@tushargoyaliit
@tushargoyaliit 4 года назад
same doubt can u explain
@lijiechen2119
@lijiechen2119 6 лет назад
I have difficulty to understand the way other guys resolve this problem by using DP solution. It is much easy to understand it by your explanation. You really help me out! Thanks!
@gauravbuche7211
@gauravbuche7211 8 лет назад
Hey Tushar! Thank you so much! Your videos are of great help! Keep it coming! :)
@TM-qc5oz
@TM-qc5oz 5 лет назад
How to come up with such an algorithm in a 45 mins interview setting. There is no explanation on how to arrive at this solution.
@romanpanchenko9009
@romanpanchenko9009 4 года назад
In 45 minutes you have to introduce yourself, have a small talk, solve the problem and then answer for additional questions. To solve a problem you have to 1) Come up with an algorithm; 2) Write code; 3) Check your code. So, I'd say you have 10-15 minutes at most to come up with an algorithm :)
@surajch2678
@surajch2678 4 года назад
ru-vid.com/video/%D0%B2%D0%B8%D0%B4%D0%B5%D0%BE-Pw6lrYANjz4.html . This should help you on the intuition behind the formula.
@ambikabasappachandrappa9409
@ambikabasappachandrappa9409 4 года назад
I like dynamic programming but I want to understand on how we arrive to a solution/formula like this...
@marjansherafati6913
@marjansherafati6913 4 года назад
@@ambikabasappachandrappa9409 think about it this way. One any given day, you either do a transaction or you don't. and your goal is to maximize the profit between these two options. Let's define a 2-D array for maximum profit of doing i interactions up until day j. T[i,j] if you don't do a transaction, your best profit will be the profit you acquired up until day j-1 ( T[i,j-1] ). and if you do a transaction, your profit will be the best combination of your past transactions (T[i-1,m]) and your current transaction (price[j] - price[m]) for each of the m days prior to this one. so between these two options (doing a transaction or not doing it) you need to find the maximum profit. hence you reach the formula on the board: T[i,j] = max ( T[i,j-1], max over m (T[i-1,m]+price[j]-price[m]) this way of reasoning about the solution is predominant in dynamic programming. Many of such problems can be solved using a similar logic (e.g. the Knapsack problem)
@ankit5373
@ankit5373 4 года назад
@@surajch2678 Thanks
@parveenchhikara6961
@parveenchhikara6961 4 года назад
I am preparing for interviews and i find your videos really helpful. Just one suggestion or correction regarding this video for the maxDiff formula : For k =3, when you are calculating the maxDiff : On board formula is written as : maxDiff = max(maxDiff, T[i-1][j] - price[j] ) In video you explained with : maxDiff = max(maxDiff, T[i-1][j-1] - price[j-1] ) ( Time of video portion 19 mins to 22 mins) I checked with Board formula , i am getting the same answer and your code is proof of correctness of board formula. Could you please check once or am i missing something?
@yingqian2034
@yingqian2034 4 года назад
Using j instead of j-1 is also correct because it just means buy on the jth day and immediately sell it on the jth day. so the adding profit is actually 0, which makes no difference.
@shatendrasingh6273
@shatendrasingh6273 2 года назад
Yes correct.
@aniruddhadesai4722
@aniruddhadesai4722 2 года назад
at 17:00. TR: i don't know if you understand that or not me: hahahaha; yes, but after replaying the section [14:00 - 17:00] about 3 times over. jokes apart, great explanation. kudos!
@gxbambu
@gxbambu 8 лет назад
Good job, I never got it before but your explanation is clear!
@speedmishra13
@speedmishra13 5 лет назад
Thanks! Much better than the highest rated leetcode comment
@evelynross1043
@evelynross1043 5 лет назад
pretty cool .. computers are dumb .. but tushar is smart .. great job .
@akashjain35
@akashjain35 4 года назад
Really helpful video with such a detailed explanation !
@kylemorgan1933
@kylemorgan1933 8 лет назад
Shouldn't it be T[i-1][m-1], instead of T[i-1][m] ?
@terrychen7673
@terrychen7673 6 лет назад
At day m, the max profit you can get is, say x. This x includes Do and Don't do transaction on day m. Even if you do the transaction on day m (say you sell, and make a profit on day m), you can still buy again on day m, and make a profit at day > m. So T[i-1][m] is correct.
@akashmehra3111
@akashmehra3111 8 лет назад
Very Helpful! Good job explaining the algo.
@atharvakulkarni3007
@atharvakulkarni3007 3 года назад
You may not engage in multiple transactions simultaneously (i.e., you must sell the stock before you buy again). i guess that T[i-1][m] should be T[i-1][m-1] right??? Correct me if I'm wrong
@manishsat
@manishsat 8 лет назад
While back tracking you said 10 is the total profit and 3 is the profit you made on 7th day, 3 is the price on 7th day not the profit. Now at 7th day we have a profit of 10 and the 10 is not coming from previous cell, which mean we did SELL on 7th day. And now previous cell is saying profit = 8 and the mean 7th day contributed in profit = 10-8 = 2, now the price is 3 at 7th day and in order to have profit of 2 we should have bought at 3-2=1 which is 6th. Same applied to day 4.
@HAAH999
@HAAH999 4 года назад
You got a new subscribe here. Great work!
@MrSachintelalwar
@MrSachintelalwar 8 лет назад
Great explanation. Just wondering in printActualSolution() method why did you define 'Deque stack = new LinkedList();' , why not simple stack something like 'Stack st = new Stack();'?
@atharvakulkarni3007
@atharvakulkarni3007 3 года назад
Thanks for the explanation and that cool optimization trick
@SaurabhPatel
@SaurabhPatel 8 лет назад
Only one word : "Awesome", Do you have trie related interview question's videos?
@SaurabhPatel
@SaurabhPatel 8 лет назад
+Tushar Roy Ok, any planning to make in near future.?
@SaurabhPatel
@SaurabhPatel 8 лет назад
Not much as I have not tried yet more problems. Still I would like to ask one question. I am talking about efficient implementation in java, what is best way to implement trieNode when we are dealing with alphabets then HashMap is good idea or array of 26 size is good idea? I think both are same. what your thoughts on this?
@SaurabhPatel
@SaurabhPatel 8 лет назад
OK thanks.
@tushargupta2356
@tushargupta2356 4 года назад
so we can get optimized solution only after figuring out the O(k*n*n) solution? or by practice one can directly get the second solution?
@jpcsr8887
@jpcsr8887 8 лет назад
It's helpful. Good diction. Thanks for the video.
@akashshukla3163
@akashshukla3163 3 года назад
Great video tushar. Just on a lighter note, was wondering about the ascent , it feels manipulated.
@ShubhamMahawar_Dancer_Actor
@ShubhamMahawar_Dancer_Actor 4 года назад
hello ,although your optimised code is running but your explanation and code doesn't match ,i think it should be like this for(j=1;j
@mebinjacob_UF
@mebinjacob_UF 5 лет назад
Thanks for the awesome explanation, one thing variables inside a for loop need not be named i, j, k always they can be named as day, transaction etc. too
@PranayKumarAggarwal
@PranayKumarAggarwal 8 лет назад
Very Helpful Tushar Sir .. :-)
@atuljoshi9187
@atuljoshi9187 4 года назад
Just didn't understand why max profit is //max(profitprevious with no transaction, (price[i] - price[m] + profit[i])) . why not we are adding profit[i-1] like T[i-1[j-1]] why T[i-1][j] , m moves from m=0...i-1 not i ?
@kuntalgorai9744
@kuntalgorai9744 2 года назад
I think there is mistake in the optimised formulae for maxDiff it should be max(maxDiff,T[i-1][j-1]-price[j-1])
@TheCodeThoughts
@TheCodeThoughts 2 года назад
correct
@swamysriman7147
@swamysriman7147 3 года назад
OK....here, a buy and a sell together are counted as a transaction right?
@prateekramani6491
@prateekramani6491 3 года назад
Last row is coming wrong as per the first formula . Is that first formula only for n-1 rows ...
@deathbombs
@deathbombs 2 года назад
How do you come up with the 2d array parameters on the first whiteboard? T[transaction][day]
@shamanthnorway
@shamanthnorway 6 лет назад
I thought we cannot buy on the same day we sell. But according to the video, it seems like we can do it. But suppose there is a cool down time 'c', then the formula is price[j] - price[m + T[i-1][m-c] where m >= c
@pramodnandy2095
@pramodnandy2095 8 лет назад
Great video Tushar with two solutions...Is der any other problem which ll have same solution procedure...Like LIS and maximum sum increasing subsequence..
@spk9434
@spk9434 7 лет назад
Can this be done recursively ? I know its not efficient. But I usually do these recursively and then convert the solution to DP. That way its more understandable. Every DP problem has a recursive sol and DP sol follows from recursive one.
@tushargoyaliit
@tushargoyaliit 4 года назад
yup it can be done
@ivyxue6443
@ivyxue6443 4 года назад
Extremely clear! Thank you so much
@puneetgarg6069
@puneetgarg6069 7 лет назад
Thanks. your explanation is very nice
@Aryan-wv6qe
@Aryan-wv6qe 7 лет назад
yes bro,but unfortunately he has not uploaded his lectures since 6 month.
@jaden2582
@jaden2582 4 года назад
crystal explanation. Well Done!
@sriramphysics5853
@sriramphysics5853 11 месяцев назад
Good work man 👏👏👏
@yuzhichu1779
@yuzhichu1779 6 лет назад
Hi Roy, Thanks for you video! But I have some confusion with this problem. Could you please help to explain it a bit? In my solution, the relation is: profit[t][i] = max(profit[t][i-1], max(price[i] - price[j] + profit[t-1][j])) for all j in range [0, i-1] and price[i]>price[j](please note to this). In my test the above relation works as fine as the solution posted in this article so I think both relations are good. But my solution is not clean and prevent me from optimizing it to O(kn).. So could anyone explain to me why we don't need consider the comparison price[i]>price[j]? Only when price[j]
@shobhitchaturvediindia
@shobhitchaturvediindia 8 лет назад
really helpful , keep it simple and effective
@steets2941
@steets2941 7 лет назад
What if i want first to sell and then buy for k transactions? i dont initialize the first column with zeros?
@kuralamuthankathirvelan
@kuralamuthankathirvelan 5 лет назад
What is the logic behind calculating the MaxDiff ?
@ayushjindal4981
@ayushjindal4981 4 года назад
why is it not price[j] - price[m] + T[i-1][m-1]...since m is already included in the new transaction group, we are left with only 0 to m-1 days with one transaction less....so I suppose it should be T[i-1][m-1] and not T[i-1][m]. Someone pls explain...
@rashmikiranpandit8962
@rashmikiranpandit8962 4 года назад
Yeah I have the same doubt, did you get it now? If yes, then pls explain @Tushar Pls solve this
@ayushjindal4981
@ayushjindal4981 4 года назад
@@rashmikiranpandit8962 not yet.. :(
@ayushjindal4981
@ayushjindal4981 4 года назад
@@rashmikiranpandit8962 hey...i got it now...this is because we can sell and purchase again on that same mth day..
@gizmogaurav
@gizmogaurav 8 лет назад
shouldnt the maxdiff = max(maxDiff ,T[i-1][j-1]-pricce[j-1])
@kartikthapar4556
@kartikthapar4556 8 лет назад
That is correct. T[i][j] = max(T[i][j-1], P[j] + max(maxDiff, T[i-1][j-1] - P[j-1]); For a transaction k, initial maxDiff = T[k-1][0]
@rajcodingworld7768
@rajcodingworld7768 8 лет назад
It's great post. I have a query about print solution did not follow the intuition behind how print solution working as it's working..
@Dan-tg3gs
@Dan-tg3gs 3 года назад
could you reexplain what exactly the "max diff" stands for in this case?
@durgeshchoudhary
@durgeshchoudhary 8 лет назад
thanks for explaining it so elegantly.
@trycoding_by_abidinghaze7
@trycoding_by_abidinghaze7 3 года назад
if t[i][j] is doing max i transactions upto jth day then shouldn't it be t[i][j]=price[j]-price[m]+t[i-1][*m-1*] instead of price[j]-price[m]+t[i-1][*m*]
@nguyenhoanvule5755
@nguyenhoanvule5755 6 лет назад
His solution is very nice, but when I implement that in Leetcode, It pass almost test cases, but last one show Memory Limit Exceeded
@raghuveernaraharisetti
@raghuveernaraharisetti 5 лет назад
same here ... do you know why yet ?
@jieyan8143
@jieyan8143 5 лет назад
Leetcode set a trap in here. If the number of maximum transactions k is much greater than the number of days, the dp algorithm for large k is not necessary and Leetcode TLE on this algorithm. Instead just use the method from Best Time to Buy and Sell Stock II when k is large. Check the adapted C++ solution in earlier comment.
@abhishekkumargupta3043
@abhishekkumargupta3043 4 года назад
@@jieyan8143 hey, thanks. It helped.
@sundeep1501
@sundeep1501 4 года назад
When you are selling at T[i] for 2nd transaction, and you assume the stock was bought between T[0] to T[i-1]. Agreed. Out of T[0] to T[i-1], let's say you bought at T[i-2]. Then your previous/1st transaction should end before T[i-2]. Not till T[i-2]. Isn't?
@anuragmanchanda
@anuragmanchanda 4 года назад
Thanks for video :) Another small update(ruby code) t = Array.new(k+1){Array.new(prices.length, 0)} i = 1 while(i
@budsyremo
@budsyremo 6 лет назад
Tushar , an improvement tip , we always memoize or store a recursive step , so if you also show a recursive solution first and then teach us how you are storing that it would be a great help and improve the quality of your tutorials .
@高飞-c8u
@高飞-c8u 8 лет назад
What if we have two stocks, is there any algorithms to solve the problem please?
@xiaoqinglin6112
@xiaoqinglin6112 6 лет назад
Geat video. You look like the guy in three idiots, the smartest one~
@jeetoppers3150
@jeetoppers3150 2 месяца назад
sir at 20:15 the maxDiff Value is 5 insted of 4
@ganapatibiswas5858
@ganapatibiswas5858 3 года назад
Great video
@sriniakhilgujulla8168
@sriniakhilgujulla8168 6 лет назад
R we allowed to sell and buy on same day? i think no pls rectify
@Paradise-kv7fn
@Paradise-kv7fn 5 лет назад
I wrote the memoized recursive function for this but couldn't come up with the bottom up solution. Can someone tell me what is the time complexity for memoized version?
@vaibhavsharma1653
@vaibhavsharma1653 5 лет назад
The reason of T[i-1][m] and not T[i-1][m-1] is beacause you can do buy sell or sell buy on same day but not buy buy or selll seell
@tushargoyaliit
@tushargoyaliit 4 года назад
ok
@ghensao4027
@ghensao4027 3 года назад
at T[2][1], how is it possible you could have transacted 2 times by the 2nd day? buy on day 1 and sold one day 2, you've completed 1, not 2 transactions
@ghensao4027
@ghensao4027 3 года назад
to answer my own question: T[i][j] is defined as max profit on day (j+1) with at most (i+1) transactions, so that makes sense
@vivekpal1004
@vivekpal1004 7 лет назад
Thanks for your efforts. Great explanation.
@rohitkumarkhatri2203
@rohitkumarkhatri2203 7 лет назад
what about this formula, min=0; Loop T[i][j]= Max{ T[ i-1] [ j ], P[ j ] - p [ min ] } if( p[ j ] < p [ min ] ) min=j;
@jamesfaust1485
@jamesfaust1485 5 лет назад
the stock market has been of immense success. i make $500 profit weekly from my stock investment with my expert analyst and asset manager Pat Brown
@climbaron3798
@climbaron3798 5 лет назад
am glad u know Pat Brown. He has also helped me earn a fortune from stock trading.
@lawsondarlington6064
@lawsondarlington6064 5 лет назад
i really appreciate the fact that Pat Brown puts his best in investors trade and he doesn’t have issues with profit payments
@jasoncole9369
@jasoncole9369 5 лет назад
i have been in trade with Pat Brown for the past Eight months now, since the firm of the last broker i was working with ran into bankruptcy. i always receive my weekly profit payment
@sambliz276
@sambliz276 5 лет назад
this is all amazing. am saving up to get into trade with Pat Brown in the forthcoming weeks. someone should give me his contact please.
@sandeepvedavyas8701
@sandeepvedavyas8701 4 года назад
You guys seriously think the best way to advertise pat brown is to leave it as a comment under a video with the words 'profit' and 'stock'? how common is it that you have 7 likes and also 6comments + your own post. All comments made before 8 months and no comments after that. Very strategic way of advertising.
@karanbobade5266
@karanbobade5266 4 года назад
HI Tushar, can I buy and sell on the same day
@audiobeginner
@audiobeginner 4 года назад
You saved me. You are god to me.
@shirleyshirley3835
@shirleyshirley3835 8 лет назад
Shouldn't maxDiff = max(maxDiff, T[i-1][j-1]-price[j-1]) based on your video?
@abhishek13395
@abhishek13395 8 лет назад
yeah it should be the same as u said
@myyoutubisthis
@myyoutubisthis 6 лет назад
His code calculates max diff before incrementing j by 1. And yours is right if its after, so both are fine with the context when it is done.
@Mankind5490
@Mankind5490 8 лет назад
11:20 lmao that voice crack ruined my attention span
@Mankind5490
@Mankind5490 8 лет назад
***** not your fault man haha don't worry. Video was still very helpful
Далее
Wildcard Matching Dynamic Programming
16:38
Просмотров 146 тыс.
Burst Balloon Dynamic Programming[Leetcode]
27:22
Просмотров 104 тыс.
The Algorithm Behind Spell Checkers
13:02
Просмотров 416 тыс.
Box Stacking Dynamic Programming
10:51
Просмотров 101 тыс.
Regular Expression Dynamic Programming
18:34
Просмотров 257 тыс.
Fast Inverse Square Root - A Quake III Algorithm
20:08